/***********************************************
  : smc_dev.c
  : Ʈ ̵ ī  ̽ ̹
 ۼ : hks9739@nate.com
 Ȩ   : http://free.h4ckers.com
 ¥ : 2003-2-5 ~
 ÷ :  ̽ ̹ 2.4 Ƽ 
		̽ ̹ ⸦  
		Ｚ Ǵ Software Driver of SmartMedia 
		Ŀ ̹ ҽ drivers/mtd/mtdblock.c
		۸ κ  Ͽ Ͽ

 ÷ : 2003. 3. 24.
		SMC ˵Ǿ MBR  찡 ִ.
		  Ű 𸣰    ...
		2003. 4. 15.
		ۿ  ִ  ⸦  Ÿ̸ ߰
		2003. 12. 27.
		PC/104 ̽ 
************************************************/


#include <linux/module.h>
#include <linux/sched.h>

#include <linux/kernel.h>	// printk... 
#include <linux/slab.h>		// kmalloc.. 
#include <linux/errno.h>
#include <linux/timer.h>
#include <linux/types.h>	// size_t... 
#include <linux/fcntl.h>
#include <linux/hdreg.h>	// HDIO_GETGEO.. 
#include <linux/fs.h>		// register_blkdev,unregi.. 
#include <linux/blkpg.h>	// blk_ioctl() 
#include <asm/system.h>		// cli(), *_flags 
#include <linux/vmalloc.h>	// vmalloc,vfree...

#include <asm/uaccess.h>	// VERIFY_WRITE,access_ok...
#include <asm/io.h>
#include <linux/ioport.h>

#include "smc_io.h"
#include "smc_dev.h"

/** 
*   ̹ ̹ ڵ ܼȭ  linux/blk.h  ϰԵȴ.
* blk.h  ϱ  ɺ  ־ Ѵ.
* MAJOR_NR  blk.h  ɺ ٸ  ǰ MAJOR_NR  
*  end_request Ǵ ũ Ϻθ  Եȴ.
**/

//blk.h  includeϱ  
#define MAJOR_NR			SMC_MAJOR				

#define DEVICE_NR(device)	(MINOR(device)>>SMC_SHIFT)
#define DEVICE_NAME			"Smart Media Card"			
#define DEVICE_REQUEST		smc_request
#define DEVICE_NO_RANDOM							
#define DEVICE_OFF(d)								

// register_disk ȣ 1̸ partition check  ʴ´. 
#define SMC_CHECK			0					    

#include <linux/blk.h>

MODULE_AUTHOR("Hyun Kyung-Seok");

#define TIMER_INTERVAL	10

//̽ ̹ ʿϰ  ü 
struct smc_dev{
	int usage;
	spinlock_t lock;
	int dev_num;						//ġ ȣ
	struct flash_info *info;			//smc flash ϵ (smc_io )
	
	//۸  
	struct	semaphore cache_sem;
	char	*cache_data;			//
	ulong	cache_block;			//ȣ
	ulong	cache_size;				// ũ
	enum { STATE_EMPTY, STATE_WRITE, STATE_READ } cache_state;	// 
	struct timer_list timer;		//  ð writeϱ 
};



// ̽ ̹ ʿ 
struct smc_dev *smc_devices = NULL;

int *smc_sizes = NULL;
int *smc_blksizes = NULL;
int *smc_hardsects = NULL;

struct block_device_operations smc_bdops;
struct hd_struct *smc_partitions = NULL;

struct gendisk smc_gendisk = {
    major:              0,              /* Major number assigned later */
    major_name:         "sm",           /* Name of the major device */
    minor_shift:        SMC_SHIFT,		/* Shift to get device number */
    max_p:              1 << SMC_SHIFT, /* Number of partitions */
    fops:               &smc_bdops,   /* Block dev operations */
};

static int smc_check_change(kdev_t i_rdev);
static int smc_revalidate(kdev_t i_rdev);
static int write_cached_data (struct smc_dev *dev);
static int cached_read(struct smc_dev *dev, ulong pos, int len, char *buf);
static int cached_write (struct smc_dev *dev, ulong pos, int len, char *buf);


/***********************************************
  : ġ 
  :
  :
***********************************************/
int smc_open (struct inode *inode, struct file *filp)
{
	struct smc_dev *dev;
	int num = DEVICE_NR(inode->i_rdev);
	
	if (num >= SMC_DEVS) return -ENODEV;
    dev = smc_devices + num;
	dev->dev_num = num;
	
	spin_lock(&dev->lock);
	
	//ġ  ϳ Ѵ.
	if(dev->usage > 0){
		spin_unlock(&dev->lock);
		return -EBUSY;
	}
	
	//޸𸮸 ⼭ Ҵ ־߸ Ѵ.  ̷?? 
	//smc_io Ҵϸ dev->info null  Ѵ. 2003.11.11
	dev->info = kmalloc(sizeof(struct flash_info), GFP_KERNEL);		

	if(!dev->info){
		spin_unlock(&dev->lock);
		return -ENOMEM;
	}
	memset(dev->info, 0, sizeof(struct flash_info));

	//ī üũ, ʱȭ
	if(init_smc(dev->info)){
		kfree(dev->info);
		spin_unlock(&dev->lock);
		return -ENODEV;
	}

	smc_sizes[num] = (dev->info->total_sector * SMC_SECTSIZE)>>10;	//KByte 
	smc_blksizes[num] = SMC_BLKSIZE;
	smc_hardsects[num] = SMC_SECTSIZE;
	
	smc_partitions[num].nr_sects = dev->info->total_sector;
	smc_partitions[num].start_sect = 0;

	dev->usage++;
    MOD_INC_USE_COUNT;

	init_MUTEX (&dev->cache_sem);
	dev->cache_state = STATE_EMPTY;
	dev->cache_size = dev->info->page_size * dev->info->page_per_block;		// ũ,Ʈ 
	dev->cache_data = vmalloc(dev->cache_size);
	
	if(dev->cache_data == NULL){
		kfree(dev->info);
		dev->usage = 0;
		MOD_DEC_USE_COUNT;
		spin_unlock(&dev->lock);
		return -ENOMEM;
	}
	
	dev->timer.expires = jiffies + TIMER_INTERVAL * HZ;	
	add_timer(&dev->timer);
	
	spin_unlock(&dev->lock);
	
	printk(KERN_INFO"SMC DEVICE OPEND !!!\n");
	return 0;          /* success */
}


/***********************************************
  : IO Ʈ
  :
  :
***********************************************/
int smc_ioctl (struct inode *inode, struct file *filp,uint cmd, ulong arg)
{
    int err, size;
	int minor = MINOR(inode->i_rdev);

	// linux/hdreg.h  
	struct hd_geometry *geo;
	
	//  󸶳 ߴ....  MINORϰ DEVICE_NR  ؼ.. 2003. 3. 25-26(Ʋ)
	struct smc_dev *dev;
	int num = DEVICE_NR(inode->i_rdev);
	if (num >= SMC_DEVS) return -ENODEV;
	dev = smc_devices + num;
	
	switch(cmd) {

      case BLKGETSIZE:
		err = ! access_ok (VERIFY_WRITE, arg, sizeof(long));
        if (err) return -EFAULT;
		//  ̴. 
		size = smc_partitions[minor].nr_sects;

		KDEBUG("IOCTL BLKGETSIZE MINOR(indoe->i_rdev)=%d, size=%d \n",MINOR(inode->i_rdev),size);
		if (copy_to_user((long *) arg, &size, sizeof (long)))
			return -EFAULT;
        return 0;

#ifdef BLKGETSIZE64
	case BLKGETSIZE64:
		KDEBUG("IOCTL BLKGETSIZE64 size=%d \n", size);
		// copy_to_user Լ  Ͱ   ´.
		return put_user((u64)smc_partitions[minor].nr_sects << 9,(u64 *)arg);
#endif

      case BLKFLSBUF: /* flush */
        KDEBUG("IOCTL BLKFLSBUF \n");
		if (! capable(CAP_SYS_RAWIO)) return -EACCES; //only root
		fsync_dev(inode->i_rdev);
        invalidate_buffers(inode->i_rdev);
        return 0;

      case BLKRAGET: // readahead 
	  	KDEBUG("IOCTL BLKRAGET \n");
        err = ! access_ok(VERIFY_WRITE, arg, sizeof(long));
        if (err) return -EFAULT;
        put_user(read_ahead[MAJOR(inode->i_rdev)],(long *) arg);
		return 0;

      case BLKRASET: // readahead  
	    KDEBUG("IOCTL BLKRASET \n");
        if (!capable(CAP_SYS_RAWIO)) return -EACCES;
        if (arg > 0xff) return -EINVAL; /* limit it */
        read_ahead[MAJOR(inode->i_rdev)] = arg;
        return 0;

      case BLKRRPART: // Ƽ ٽ б
	  	KDEBUG("IOCTL BLKRRPART \n");
        return smc_revalidate(inode->i_rdev);

      case HDIO_GETGEO:
		KDEBUG("IOCTL HDIO_GETGEO \n");
        geo = (struct hd_geometry *)arg;
		err = ! access_ok(VERIFY_WRITE, arg, sizeof(*geo));
        if (err) return -EFAULT;
		
		put_user((short)dev->info->cylinder, (short *)&geo->cylinders);
		put_user((char)dev->info->head, (char *)&geo->heads);
		put_user((char)dev->info->sector, (char *)&geo->sectors);
		put_user(smc_partitions[minor].start_sect, (ulong *)&geo->start);

		KDEBUG("CpV=%d, HpC=%d, SpH=%d Start=%ld\n", geo->cylinders,  geo->heads, geo->sectors, geo->start);
		
		return 0;
	  
	  default:
		KDEBUG("IOCTL DEFAULT \n");
        return blk_ioctl(inode->i_rdev, cmd, arg);
    }

    return -ENOTTY;
}


/***********************************************
  : ġ ȭ üũ
  :
  :
***********************************************/
int smc_check_change(kdev_t i_rdev)
{
	int minor = DEVICE_NR(i_rdev);
    //struct smc_dev *dev = smc_devices + minor;
	
	KDEBUG("check_change for dev %i \n",minor);

    if (minor >= SMC_DEVS) /* paranoid */
        return 0;
	
	//׻ 1 ȯϰ Ѵ.(ϴ) ׷߸ Ƽ ̺ ݿѴ.
	return 1;
}

/***********************************************
  : ġ ݱ
  :
  :
***********************************************/
int smc_release (struct inode *inode, struct file *filp)
{
	struct smc_dev *dev = smc_devices + DEVICE_NR(inode->i_rdev);

    spin_lock(&dev->lock);
	dev->usage--;
	MOD_DEC_USE_COUNT;

	// ۿ ִ ͸  ȵȴ..  2003. 3. 26  
	if(dev->cache_state == STATE_WRITE)
		write_cached_data(dev);
	
	if(dev->cache_data != NULL){
		vfree(dev->cache_data);
		dev->cache_data = NULL;
	}

	del_timer(&dev->timer);			//Ÿ̸ 
	close_smc(dev->info);	//޸ 

	spin_unlock(&dev->lock);


	printk(KERN_INFO"smc is released.. \n");
	
    return 0;
}




/***********************************************
  : Ƽ üũѴ.
  :
  :
***********************************************/
int smc_revalidate(kdev_t i_rdev)
{
	/*****************************************************************************
	 ġ  뷮 ԷѴ.(å  ִ  ҽ)
	   register_disk(grok_partitions) ش.
	 register_disk ٷ grok_partitions ȣϰ ȴ.register_partitions̶ Լ    ʹ.
	 register_disk ȣ block_device_operationsڴ ƹ͵  ʴ´. ׸ ٷ grok_partitions ȣѴ.
	 fs/partitions/check.c 
	******************************************************************************/

    printk(KERN_INFO "smc partition check: (%d) \n", DEVICE_NR(i_rdev));
	
	// fs/partitions/check.c   Ǿ ִ.
	// size(ͼ, ) 0̰ų SMC_CHECK 1 ̸ Ƽ üũ  ʴ´.
    register_disk(&smc_gendisk, i_rdev, SMC_CHECK, &smc_bdops, smc_partitions[DEVICE_NR(i_rdev)].nr_sects);
	
	return 0;
}


struct block_device_operations smc_bdops = {
    open:       smc_open,
    release:    smc_release,
    ioctl:      smc_ioctl,
    revalidate: smc_revalidate,
    check_media_change: smc_check_change,
};



/***********************************************
  : ۿ  Ǿ ͸ ġ .
  :
  :
***********************************************/
static int write_cached_data (struct smc_dev *dev)
{
	KDEBUG("WRITING CACHED DATA \n");
	dev->cache_state = STATE_EMPTY;
	return write_block(dev->info, dev->cache_block, dev->cache_data, dev->cache_size);
}

/***********************************************
  :  ð ۾    ͸ Ѵ.Ÿ̸ӿ  ȣ
  :
  :
***********************************************/
void smc_expires(unsigned long data)
{
	struct smc_dev *dev = (struct smc_dev *)data;
	//KDEBUG("TIMER CALL\n");
	
	//fsync_dev(MKDEV(SMC_MAJOR, 0));	//Ŀ д
	
	spin_lock(&dev->lock);
	
	//ۿ  ִ ͸  ش.
	if(dev->cache_state == STATE_WRITE)
		write_cached_data(dev);
	
	spin_unlock(&dev->lock);
	dev->timer.expires = jiffies + TIMER_INTERVAL * HZ;	//Ÿ̸Ӹ ٽ Ѵ.
	add_timer(&dev->timer);
	
}

/***********************************************
  :        ϸ ͸ óѴ.
  :
  :
***********************************************/
static int cached_write (struct smc_dev *dev, ulong pos, int len, char *buf)
{
	ulong	block_size = dev->cache_size/SMC_SECTSIZE;	//  io Ͼ( ͼ)
	ulong	start_sector;	
	ulong	block_num;
	ulong	offset;				// ȣ ƴ϶ Ʈ  offset Ÿ.
	ulong	size;

	//  512Ʈ θ Ͼ.
	while (len > 0) {
		block_num = pos/block_size;					//pos  ȣ̴.  ȣ  ũ  ش.
		start_sector = block_num * block_size;		//û Ͱ   ó ۵Ǵ  ȣ
		offset = (pos - start_sector) * SMC_SECTSIZE;		//   offset, Ʈ
		size = dev->cache_size - offset;			// ִ ִ , Ʈ
		
		//KDEBUG("write %ld, %ld, %ld, %ld\n", block_num, start_sector, offset, size);
				
		if( size > len )		//   ũⰡ    ũ⺸ ũٸ
			size = len;			//  ũ  ش.
		
		//  ¿ ۿ  Ǿ ִ ͸  ־ Ѵ.
		if (dev->cache_state == STATE_WRITE && dev->cache_block != block_num) {
			write_cached_data(dev);
		}

		//ο       Ǿ ִ  ۿ Ͽ Ѵ.
		//smc   erase    ..
		if (dev->cache_state == STATE_EMPTY && dev->cache_block != block_num) {
			if(read_block(dev->info, block_num, dev->cache_data, dev->cache_size) < 0){
				return -1;
			}
			dev->cache_block = block_num;
		}

		/* write data to our local cache */
		memcpy (dev->cache_data + offset, buf, size);
		dev->cache_state = STATE_WRITE;

		buf += size;
		pos += size;
		len -= size;
	}

	return 0;
}

/***********************************************
  :        ϸ ͸ óѴ.
  :
  :
***********************************************/
static int cached_read(struct smc_dev *dev, ulong pos, int len, char *buf)
{
	uint	block_size = dev->cache_size/SMC_SECTSIZE;		//  io Ͼ( ͼ)
	ulong	start_sector;	
	ulong	block_num;
	ulong	offset;				// ȣ ƴ϶ Ʈ  offset Ÿ.
	ulong	size;
	
	while (len > 0) {
		block_num = pos/block_size;
		start_sector = block_num * block_size;				//û Ͱ   ó ۵Ǵ  ȣ
		offset = (pos - start_sector) * SMC_SECTSIZE;		//   offset, pos  
		size = dev->cache_size - offset;
		
		if (size > len) 
			size = len;

		 //   ۿ Ǿ   Ǹ Ǿ   ׳ н Ǵ 찡 Ƿ
		 //  Ŀ ͸ ش(2003. 3. 25)
		 if(dev->cache_state == STATE_WRITE){
			write_cached_data(dev);
		 }

		 //û  ۿ ִ      ´
		if (dev->cache_state == STATE_READ && dev->cache_block == block_num) {
			memcpy (buf, dev->cache_data + offset, size);
		} else {
			if(read_block(dev->info, block_num, dev->cache_data, dev->cache_size) < 0){
				return -1;
			}
			
			//  ¸  
			dev->cache_block = block_num;
			dev->cache_state = STATE_READ;
			memcpy (buf, dev->cache_data + offset, size);
		}

		buf += size;
		pos += size;
		len -= size;
	}

	return 0;

}

/***********************************************
  :  ۰, smc_request  ȣ
  :
  :
***********************************************/
static int smc_transfer(struct smc_dev *dev, const struct request *req)
{
    int size, minor;
	ulong start_sector;
	int err;
	
	minor = MINOR(req->rq_dev);
    
	//    ȣ
    start_sector = smc_partitions[minor].start_sect + req->sector;
	size = req->current_nr_sectors*SMC_SECTSIZE;
    
	//KDEBUG("req->sector= %ld,smc_partitions[%d].nr_sects = %ld \n",req->sector,minor,smc_partitions[minor].nr_sects);
        
	if (req->sector + req->current_nr_sectors > smc_partitions[minor].nr_sects) {
		static int count = 0;
        
		KDEBUG("end error : req->sector= %ld,smc_partitions[%d].nr_sects = %ld \n",req->sector,minor,smc_partitions[minor].nr_sects);
        if (count++ < 5)
            printk(KERN_WARNING "smc: request past end of partition\n");
        return 0;
    }
 
	switch(req->cmd) {
        case READ:
			//KDEBUG("smc_transfer -> read : num=%ld size=%d \n",start_sector,size);
			down(&dev->cache_sem);
			err = cached_read (dev, start_sector, size, req->buffer);
			up(&dev->cache_sem);
			
			if(err < 0)	return 0;
			return 1;
        case WRITE:
			//KDEBUG("smc_transfer -> write : num=%ld size=%d \n",start_sector,size);
	        down(&dev->cache_sem);
			err = cached_write(dev, start_sector, size, req->buffer);
			up(&dev->cache_sem);

			if(err < 0)	return 0;
			return 1;
        default:
            KDEBUG("smc_transfer -> default \n");
			return 0;
        }
}


/***********************************************
  : request 
  :
  :
***********************************************/
void smc_request(request_queue_t *q)
{
    struct smc_dev *device;
	int num;
    int status;
    long flags;

    while(1) {
        INIT_REQUEST;  //returns when queue is empty 

       // CURRENT struct request ̴.
	   num = DEVICE_NR(CURRENT->rq_dev);
	   if(num >= SMC_DEVS) continue;
	   
	   device = smc_devices + num;
	   
	   if (device == NULL) {
            end_request(0);
            continue;
        }
		
		spin_lock_irqsave(&device->lock, flags);
        status = smc_transfer(device, CURRENT);
        spin_unlock_irqrestore(&device->lock, flags);
        end_request(status);
    }
}


/***********************************************
  :  ʱȭ
  :
  :
***********************************************/
int init_module(void)
{
    int result, i;
	
	if (check_mem_region (SMC_BASE, SMC_REGION)) {
		printk(KERN_INFO "Can't Allocate %x \n", SMC_BASE);
		return -1;
	}

	//ϰ ϴ IO ޸  Ѵ.
	request_mem_region(SMC_BASE, SMC_REGION, DEVICE_NAME);

	isa_addr = ioremap(SMC_BASE, SMC_REGION);
	
	result = register_blkdev(SMC_MAJOR, DEVICE_NAME, &smc_bdops);
    if (result < 0) {
        printk(KERN_WARNING "smc: can't get major %d\n",SMC_MAJOR);
		iounmap(isa_addr);
	    return result;
    }

	smc_gendisk.major = SMC_MAJOR;
	
	// ̽ ġ  ŭ ü ϰ ʱȭ Ѵ.
	smc_devices = kmalloc(SMC_DEVS * sizeof (struct smc_dev), GFP_KERNEL);
    if (!smc_devices)
        goto fail_malloc;
    memset(smc_devices, 0, SMC_DEVS * sizeof (struct smc_dev));
    

	// ۸  Ÿ̸Ӹ ʱȭ Ѵ.
	for (i=0; i < SMC_DEVS; i++){
        spin_lock_init(&smc_devices[i].lock);
		init_timer(&(smc_devices[i].timer));
		smc_devices[i].timer.data = (unsigned long)(smc_devices+i);
        smc_devices[i].timer.function = smc_expires;
	}


/********************************************************************
	linux/blkdev.h  ǵ ʵ ..
	blk_size[major][minor]  ̽ ũ⸦ ų Ʈ  
	blksize_size[major][minor] ̽  Ǵ  Ʈ , ⺻ 1KB̰ 2  Ѵ.
	harsect_size[major][minor] ϵ ũ,⺻ 512Ʈ
	read_ahead[major] Ŀο  ̸  ͼ
*********************************************************************/	

    result = -ENOMEM; 
	
	read_ahead[SMC_MAJOR] = SMC_RAHEAD;
	
	//ġ ũ(KB), open ȣǸ鼭  
    smc_sizes = kmalloc( (SMC_DEVS << SMC_SHIFT) * sizeof(int),GFP_KERNEL);
    if (!smc_sizes) goto fail_malloc;
    memset(smc_sizes, 0, (SMC_DEVS << SMC_SHIFT) * sizeof(int));
	
	blk_size[SMC_MAJOR] = smc_gendisk.sizes = smc_sizes;
	
	// (BYTE), open ȣǸ鼭  
	smc_blksizes = kmalloc((SMC_DEVS << SMC_SHIFT) * sizeof(int),GFP_KERNEL);
	if(!smc_blksizes) goto fail_malloc;
	memset(smc_blksizes, 0, (SMC_DEVS << SMC_SHIFT) * sizeof(int));

    blksize_size[SMC_MAJOR] = smc_blksizes;

	// ũ(BYTE)
	smc_hardsects = kmalloc((SMC_DEVS << SMC_SHIFT) * sizeof(int),GFP_KERNEL);
	if(!smc_hardsects)	goto fail_malloc;
	memset(smc_hardsects, 0, (SMC_DEVS << SMC_SHIFT) * sizeof(int));

    hardsect_size[SMC_MAJOR] = smc_hardsects;

    /* Allocate the partitions array. */
    smc_partitions = kmalloc( (SMC_DEVS << SMC_SHIFT) * sizeof(struct hd_struct), GFP_KERNEL);
    if (!smc_partitions)
        goto fail_malloc;

    memset(smc_partitions, 0, (SMC_DEVS << SMC_SHIFT) * sizeof(struct hd_struct));

    smc_gendisk.part = smc_partitions;
    smc_gendisk.nr_real = SMC_DEVS;

    // κ add_gendisk  ϴ° .
    smc_gendisk.next = gendisk_head;
    gendisk_head = &smc_gendisk; 

	blk_init_queue(BLK_DEFAULT_QUEUE(SMC_MAJOR), smc_request);
   
	// Ŀ 2.4 ̻󿡼 ʿ  Լ.. ƹϵ (ó ڰ NULL̸)
    //for (i = 0; i < dev_counts; i++)
    //        register_disk(NULL, MKDEV(major, i), 1, &smc_bdops, smc_size << 1);

    printk (KERN_INFO"smc: init module complete \n");
    return 0; /* succeed */

  fail_malloc:
    read_ahead[SMC_MAJOR] = 0;
    if (smc_devices) kfree(smc_devices);
    if (smc_sizes) kfree(smc_sizes);
    if (smc_blksizes) kfree(smc_blksizes);
    if (smc_hardsects) kfree(smc_hardsects);
	if (smc_partitions) kfree(smc_partitions);
	blk_size[SMC_MAJOR] = NULL;

    unregister_blkdev(SMC_MAJOR, DEVICE_NAME);
    return result;
}

/***********************************************
  :  
  :
  :
***********************************************/
void cleanup_module(void)
{
	struct gendisk **gdp;

    unregister_blkdev(SMC_MAJOR, DEVICE_NAME);

	blk_cleanup_queue(BLK_DEFAULT_QUEUE(SMC_MAJOR));

	iounmap(isa_addr);
    release_mem_region(SMC_BASE, SMC_REGION);

	read_ahead[SMC_MAJOR] = 0;
    blk_size[SMC_MAJOR] = NULL;
    blksize_size[SMC_MAJOR] = NULL;
	
	for (gdp = &gendisk_head; *gdp; gdp = &((*gdp)->next))
        if (*gdp == &smc_gendisk) {
            *gdp = (*gdp)->next;
            break;
        }


	// blk_size[SMC_MAJOR]    ٽ smc_sizes  ϰԵǸ  ȵȴ.
	if (smc_devices) kfree(smc_devices);
    if (smc_sizes) kfree(smc_sizes);
    if (smc_blksizes) kfree(smc_blksizes);
    if (smc_hardsects) kfree(smc_hardsects);
	if (smc_partitions) kfree(smc_partitions);
    
	printk (KERN_INFO"smc: unregister module complete\n");

}
