/***********************************************************
   : smc_io.c
   : 漮(hks9739@nate.com)
Ȩ : http://free.h4ckers.com
   : 2003 11 7
   : 2003 12 26 ~
     : smc ÷  ＼ κ, Ʈδ    κ ̿Ͽ.
************************************************************/

#include <linux/module.h>
#include <linux/sched.h>
#include <linux/kernel.h>	// printk... 
#include <linux/slab.h>		// kmalloc.. 

#include <linux/ioport.h>

#include <asm/io.h>			//writeb,readb...
#include <asm/delay.h>		//udelay..
#include <linux/types.h>

#include "smc_io.h"

uchar ctlres;
void *isa_addr;


//,  ȣ ȭ  Ǿ 
#define		P_ZONE_SIZE		1024
#define		L_ZONE_SIZE		1000


/***********************************************
  : delay Ÿ ش. Ʈδ (udelay)
  :
  :
***********************************************/
void dummy(){ return; }

void delay(long delay){
	do{ 
		dummy(); 
	}while(delay--);
}


/***********************************************
  : ÷   д´.
  :   ũ⸦ Ѵ.
  :  κ   κи д´.   ȣ() д´.
***********************************************/
static int read_page(struct flash_info *info, ushort page_num, uchar *data, ushort size){
	int i;
	uchar row_addr[3];

	if(page_num > info->total_pblock*info->page_per_block){		// ȣ ü    
		printk("Can't Read Page.. PAGE NUM IS WRONG !!!\n");
		return -1;
	}

	if(size > info->page_size) size = info->page_size;	//page  ͸ о δ.

	row_addr[0] = (page_num >> 0) & 0xff;
	row_addr[1] = (page_num >> 8) & 0xff;
	switch(info->type){
		case TYPE_SAMSUNG_64M:
			row_addr[2] = (page_num >> 16) & 0x01;
			break;
		case TYPE_SAMSUNG_128M:
			row_addr[2] = (page_num >> 16) & 0x02;
			break;
	}
	
	smc_enable();
	smc_write_cmd( CMD_READ);
	
	smc_write_addr( 0x00);
	smc_write_addr( row_addr[0]);
	smc_write_addr( row_addr[1]);
	smc_write_addr( row_addr[2]);

	smc_read_wait();
	
	for(i=0; i<size; i++){
		*data++ = smc_read_data();
	}

	smc_disable();
	
	return size;
}


/***********************************************
  :    д´.
  :
  :   ȣ д´.
***********************************************/
static int read_spare(struct flash_info *info, ushort page_num, uchar *data, ushort size){
	int i;
	uchar row_addr[3];
	
	if(page_num > info->total_pblock*info->page_per_block){		// ȣ ü    
		printk("Can't Read Page.. PAGE NUM IS WRONG !!!\n");
		return -1;
	}

	if(size > info->spare_size) size = info->spare_size;	//spare  ۰Ը о δ.
	

	row_addr[0] = (page_num >> 0) & 0xff;
	row_addr[1] = (page_num >> 8) & 0xff;
	switch(info->type){
		case TYPE_SAMSUNG_64M:
			row_addr[2] = (page_num >> 16) & 0x01;
			break;
		case TYPE_SAMSUNG_128M:
			row_addr[2] = (page_num >> 16) & 0x02;
			break;
	}

	smc_enable();
	
	smc_write_cmd( CMD_READ_SPARE);
	smc_write_addr( 0x00);				// spare   ÷ 0
	smc_write_addr( row_addr[0]);
	smc_write_addr( row_addr[1]);
	smc_write_addr( row_addr[2]);
	
	smc_read_wait();

	for(i=0; i<size; i++){
		*data++ = smc_read_data();
	}

	smc_disable();
	
	return size;
}

/***********************************************
  :  .
  :
  :  ȣ ڷ ޴´. 
***********************************************/
static bool erase_block(struct flash_info *info, ushort pblock_num){
	unsigned long page_num;
	uchar row_addr[3];
	uchar state;

	if(info->pblock[pblock_num] == BAD_BLOCK){			//  쿡   ȴ.
		printk("BLOCK[%d] IS BAD BLOCK. CAN'T ERASE !!!\n", pblock_num);
		return false;
	}

	page_num = pblock_num * info->page_per_block;		// ȣ   ŭ ̵ؾ Ѵ.
	
	row_addr[0] = (page_num >> 0) & 0xff;
	row_addr[1] = (page_num >> 8) & 0xff;
	switch(info->type){
		case TYPE_SAMSUNG_64M:
			row_addr[2] = (page_num >> 16) & 0x01;
			break;
		case TYPE_SAMSUNG_128M:
			row_addr[2] = (page_num >> 16) & 0x02;
			break;
	}
	
	smc_enable();
	smc_write_cmd( CMD_BLOCK_ERASE);		//  ɿ row addrees  ȴ.
	
	smc_write_addr( row_addr[0]);
	smc_write_addr( row_addr[1]);
	smc_write_addr( row_addr[2]);
	
	smc_write_cmd( CMD_BLOCK_ERASE_END);

	smc_wait();		//   2ms, ִ3ms  ִ.

	do{
		smc_write_cmd( CMD_READ_STATUS);
		state = smc_read_data();
	}while( (state & (1<<6) ) == 0);			// 6° Ʈ 0 ̸ BUSY ̴.

	smc_disable();
	
	if( (state & (1<<0)) != 0){				//0° Ʈ 0 ƴϸ ERASE ̴.
		printk("ERASE PBLOCK[%d] FAIL !!!\n", pblock_num);
		return false;
	}

	KDEBUG("ERASE PBLOCK[%d] SUCCEED !!!\n", pblock_num);

	return true;

}

/***********************************************
  :   ⸦ Ѵ.
  : 
  : ⸦ Ҷ     ش.
***********************************************/
static bool write_page(struct flash_info *info, ulong page_num, uchar* data, uchar* spare){
	uchar row_addr[3];
	uchar state;
	int i;
	
	row_addr[0] = (page_num >> 0) & 0xff;
	row_addr[1] = (page_num >> 8) & 0xff;
	switch(info->type){
		case TYPE_SAMSUNG_64M:
			row_addr[2] = (page_num >> 16) & 0x01;
			break;
		case TYPE_SAMSUNG_128M:
			row_addr[2] = (page_num >> 16) & 0x02;
			break;
	}

	smc_enable();
	smc_write_cmd( CMD_PAGE_PROGRAM);
	
	smc_write_addr( 0x00);
	
	smc_write_addr( row_addr[0]);
	smc_write_addr( row_addr[1]);
	smc_write_addr( row_addr[2]);
	
	for(i=0; i<info->page_size; i++)
		smc_write_data(*data++);
	
	for(i=0; i<info->spare_size; i++)
		smc_write_data(*spare++);

	smc_write_cmd( CMD_PAGE_PROGRAM_END);

	smc_wait();		//   200us, ִ 500us

	do{
		smc_write_cmd( CMD_READ_STATUS);
		state = smc_read_data();
	}while( (state & (1<<6) ) == 0);			// 6° Ʈ 0 ̸ BUSY ̴.

	smc_disable();
	
	if( (state & (1<<0)) != 0){				//0° Ʈ 0 ƴϸ ERASE ̴.
		printk("PAGE[%ld] PROGRAM FAIL !!!\n", page_num);
		return false;
	}
	
	return true;

}


/***********************************************
  :   ⸦ Ѵ.
  :  ȣ ǹѴ.
  :     Ⱑ Ǿ ϹǷ ׿ 
		 ׵  ־ Ѵ.
***********************************************/
int write_block(struct flash_info *info, ushort lblock_num, uchar* data, ulong size){
	ushort pblock_num, lba ;
	ulong page_num;
	uchar spare[16];
	uchar parity;
	uchar *pdata;
	int i;

	//ܺο ȣǹǷ ʱȭ θ ǴϿ Ѵ.
	if(info->detect == false){
		printk("Can't Write Block.. FLASH IS NOT DETECTED !!!\n");
		return -1;
	}

	if(lblock_num >= info->total_lblock){
		printk("Can't Write Block.. BLOCK NUMBER IS WRONG !!!\n");
		return -1;
	}

	pblock_num = info->lblock[lblock_num];			//  ȣ  ´.

	//ϰ ϴ   Ҵ     
	if(pblock_num == UNASSIGNED_BLOCK){
		ushort pos, zone, max;

		//ûϴ ּ ش (zone) Ҵ Ǿ Ѵ.
		zone = lblock_num/L_ZONE_SIZE;	//ûϴ ּҰ شǴ 

		//  Ǿ ʴ   Ƿ ãƳ.

		// jiffies Ѵ.(Լ  ??)
		pos =	zone*P_ZONE_SIZE + jiffies%P_ZONE_SIZE;
		max = (zone+1)*P_ZONE_SIZE;

		for(i=0; i<P_ZONE_SIZE; i++, pos++){
			if( pos >= max)				//   
				pos = zone*P_ZONE_SIZE;
			
			if(info->pblock[pos] == UNUSED_BLOCK){	// ʴ  
				pblock_num = pos;
				info->lblock[lblock_num] = pos;		//ϰ    ּ
				KDEBUG(" NEW ALLOCATE [%d] \n", pos);
				break;
			}
		}

		if(i == P_ZONE_SIZE){
			printk("Can't allocate Block !!! \n");
			return -1;
		}
	}//else{	
	//Ҵ      ־  ׷ġ  쵵   Ƿ  ش.
	if(!erase_block(info, pblock_num)) return -1;
	//}

	
	//spare   Ǿ ͸ Ѵ.
	memset(spare, 0xFF, 16);
	lba = lblock_num%L_ZONE_SIZE;	// ּҸ Ŀ ° ٲش.
	
	parity = 1;						//иƼ   ش. scan_block Լ 
	for(i=0; i<10; i++)				//10 Ʈ(1024) ּҰ ̷ ִ.
		parity ^= (lba>>i) & 0x01;
	
	lba = 0x1000 | (lba << 1) | parity;	

	spare[6] = spare[11] = (uchar)((lba>>8)&0xff);
	spare[7] = spare[12] = (uchar)((lba>>0)&0xff);
	
	info->pblock[pblock_num] = lba;
		
	page_num = pblock_num*info->page_per_block;		//  ȣ   ̴.
	
	pdata = data;
	for(i=0; i<info->page_per_block; i++,page_num++){

		if((pdata+info->page_size) > (data+size)) break;	//    Ѿ ׸Ѵ.
		write_page(info, page_num, pdata, spare); 
		pdata += info->page_size;
	}

	size = pdata - data;

	KDEBUG("PBLOCK[%d] WRITE SUCCEED !!!\n", pblock_num);

	return size;
}

/***********************************************
  :   б⸦ Ѵ.
  :
  : 
***********************************************/
int read_block(struct flash_info *info, ushort lblock_num, uchar* data, ulong size){
	int i;
	ushort pblock_num;
	ulong page_num;
	uchar* pdata;
	
	if(info->detect == false){
		printk("Can't Read Block.. FLASH IS NOT DETECTED !!!\n");
		return -1;
	}

	if(lblock_num >= info->total_lblock){
		printk("Can't Read Block.. BLOCK NUMBER IS WRONG !!!\n");
		return -1;
	}

	KDEBUG("READ LBLOCK[%d] !!!\n", lblock_num);

	pblock_num = info->lblock[lblock_num];				//  ȣ  ´.
	
	page_num = pblock_num*info->page_per_block;			//  ȣ   ̴.

	pdata = data;
	for(i=0; i<info->page_per_block; i++,page_num++){

		if((pdata+info->page_size) > (data+size)) break;		//    Ѿ ׸Ѵ.
		
		read_page(info, page_num, pdata, info->page_size); 
		pdata += info->page_size;
	}

	size = pdata - data;

	KDEBUG("READ PBLOCK[%d] !!!\n", pblock_num);

	return size;
}


/***********************************************
  : ÷   üũϰ   Ѵ.
  :
  : SPARE  6° ͸ üũϿ  θ üũѴ.
		7° 8° ʹ   ȣ ǹѴ.
***********************************************/
static void scan_block(struct flash_info *info){
	int i,j;
	ushort zone, loff;
	ushort pblock_num, pblock_end;
	ushort lba, parity;
	
	uchar spare[16];					//ִ 16 ´
	ulong page_num;

	info->bad_blocks = 0;
	
	for(i=0; i<info->total_pblock; i++){
		page_num = i * info->page_per_block;			// ȣ   ŭ ̵ؾ Ѵ.		
		read_spare(info, page_num, spare, info->spare_size);	//spare  ͸  ´.
		
		//ȿ  üũ Ҷ 0 2Ʈ ̻    Ѵ.(SSFDC )
		if(spare[5] == 0xff){	//ȿ    ȣ ԷѴ.
			//518° Ʈ ǰ 519° Ͱ Ʈ ȴ.
			info->pblock[i] = ((ushort)spare[6] << 8 | spare[7]);
		}else{	//  Ʈ  1  Ͽ  ȿ üũѴ.
			int count=0;
			for(j=0; j<8; j++)
				if( (spare[5]>>j) & 0x01)	//Ʈ 1  üũѴ.
					count++;
			
			if(count < 7){
				info->pblock[i] = BAD_BLOCK;
				info->bad_blocks++;
			}else
				info->pblock[i] = ((ushort)spare[6] << 8 | spare[7]);
		}
	}


	printk("Total Bad Blocks [%d]\n", info->bad_blocks);

	// unassigned_block 0 Ǵµ  0   ǹǷ
	//  ּ 0 Ű  Ҵ   ȴ.
	memset(info->lblock, UNASSIGNED_BLOCK, sizeof(ushort)*info->total_pblock);
	
	/*************************************************
	 ּҴ    Ǿ ִ.
			D7	D6	D5	D4	D3	D2	D1	D0
	518		0	0	0	1	0	BA9	BA8	BA7
	519		BA6	BA5	BA4	BA3	BA2	BA1	BA0	P

	 ּҸ  2^10 ۿ ּ ǥ ȵǹǷ 1024
	ZONE  Ͽ. δ 1000  Ѵ.
	*************************************************/

	for(zone=0; zone<(info->total_pblock/P_ZONE_SIZE) + 1; zone++){
		//  ǥҶ °(ش)
		loff = zone*L_ZONE_SIZE;

		//zone     ش.
		if(info->total_pblock < P_ZONE_SIZE*(zone+1)) pblock_end = info->total_pblock;
		else pblock_end = P_ZONE_SIZE*(zone+1);

		for(pblock_num=zone*P_ZONE_SIZE; pblock_num<pblock_end; pblock_num++){
	
			lba = info->pblock[pblock_num];
			
			//  ȿ ʰų 0 (CIS)̸  Ѿ.
			//  ȣ ȯ ̴.  0  1001 ȴ.
			if(lba == BAD_BLOCK || lba == UNUSED_BLOCK || lba == 0) continue;
		
			//иƼ üũ Ѵ.
			parity = 0;
			
			// Ʈ иƼ Ʈ̸  ͸ ̿Ͽ üũѴ. ^ => XOR
			for(j=1; j<16; j++) 
				parity ^= (lba>>j) & 0x01;
			
			if( (lba&0x01) != parity) continue;
	
			//  ּҴ иƼ Ʈ  ȿ 巹  0x3ff  
			//°  ༭ 
			lba = ((lba>>1) & 0x3ff) + loff;

			info->lblock[lba] = pblock_num;
		}
	}
}


/***********************************************
  : ޸ 
  :
  :
***********************************************/
void close_smc(struct flash_info* info){
	
	if(info){
		if(info->pblock) kfree(info->pblock);
		if(info->lblock) kfree(info->lblock);
	}

}

/***********************************************
  : ʱȭ, id üũѴ.
  :
  :
***********************************************/
int init_smc(struct flash_info* smc_info){

	uchar  maker, size, code3, code4;
	
	if(!smc_info) return -1;

	//ϵ  ʱȭ,,  Ư ٲ ..
	init_device();
	
	printk( "\nSMC Check ...........................\n" );
	
	//SMC ̵ üũ Ѵ.
	smc_enable();
	
	smc_write_cmd( CMD_READ_ID);
	smc_write_addr( 0);
	
	maker = smc_read_data();
	size = smc_read_data();
	code3 = smc_read_data();
	code4 = smc_read_data();
	
	smc_disable();

	printk( "  SMC Maker ID [%02X]  ", maker);
	printk( "  SMC Size  ID [%02X]\n", size);
    printk( "  SMC Page,Block ... ID [%02X]\n", code4);
	

	switch(maker){
		case SAMSUNG:
			switch(size){
				case TYPE_SAMSUNG_128M:
					smc_info->type = TYPE_SAMSUNG_128M;
					smc_info->page_size = 512;
					smc_info->spare_size = 16;
					smc_info->page_per_block = 32;
					smc_info->total_pblock = 8192;
					smc_info->total_lblock = 8000;

					smc_info->cylinder = 500;
					smc_info->head = 16;
					smc_info->sector = 32;
					smc_info->total_sector = 256000;
					
					smc_info->detect = true;
					printk("DETECT SAMSUNG 128MBytes SMC !!!\n");
					break;
				case TYPE_SAMSUNG_64M:
					smc_info->type = TYPE_SAMSUNG_64M;
					smc_info->page_size = 512;
					smc_info->spare_size = 16;
					smc_info->page_per_block = 32;
					smc_info->total_pblock = 4096;
					smc_info->total_lblock = 4000;

					smc_info->cylinder = 500;
					smc_info->head = 8;
					smc_info->sector = 32;
					smc_info->total_sector = 128000;
					
					smc_info->detect = true;
					printk("DETECT SAMSUNG 64MBytes SMC !!!\n");
					break;
		
		
		
				default:
					smc_info->detect = false;
					printk("UNKNOWN TYPE OF SAMSUNG SMC !!!\n");
			}
			break;
		default:
			printk("CAN'T DETECT SMC !!!\n");
			smc_info->detect = false;
	}
	
	if(smc_info->detect){
		
		smc_info->pblock = kmalloc(smc_info->total_pblock*sizeof(ushort), GFP_KERNEL);
		smc_info->lblock = kmalloc(smc_info->total_lblock*sizeof(ushort), GFP_KERNEL);
	
		scan_block( smc_info);
	
		return 0;
	}
	
	return -1;
}

