/*
   : smc_io.h
   : 漮
   : 2003  11 7 ~
     : 2003 12 26 ~
     : 
		  PC/104 ̽ 
*/


#ifndef _SMC_IO_H_
#define _SMC_IO_H_


//ŸԵ Ѵ...  Ÿϵ..
#ifndef true
#define true		1
#endif	

#ifndef false
#define false		0
#endif	

#ifndef null
#define null		(void*)0
#endif	

#ifndef bool
#define bool	char
#endif

#ifndef uchar
#define uchar	unsigned char
#endif

#ifndef ushort
#define ushort	unsigned short
#endif

#ifndef uint
#define uint	unsigned int
#endif

#ifndef ulong
#define ulong	unsigned long
#endif

#undef KDEBUG
#ifdef SMC_DEBUG
#	ifdef __KERNEL__
#		define KDEBUG(fmt,args...) printk("<1>smc_debug: " fmt,## args)
#	endif
#else
#	define KDEBUG(fmt,args...)	/* KDEBUG Ǿ   ƹ͵ Ѵ. */
#endif

//ϰ  巹   ּ
#define SMC_REGION		0x1000
#define SMC_BASE		0xD0000

//巹
extern void* isa_addr;	// SMC   ּ	


#define NCE_OFFSET		(1 << 0)

//巹  ̿Ͽ ALE,CLE  Ѵ.
//ġ(74573) ̿Ͽ ALE,CLE  Ϸ ϴ  Ǽ 巹 ̿ϰ Ǿ.(2003, 12)
#define	ALE_OFFSET		(1 << 8)
#define CLE_OFFSET		(1 << 7)

#define DATA_ADDR	(void*)(isa_addr + 0)
#define CTL_ADDR	(void*)(isa_addr + 1)

#define ALE_ADDR	(void*)(isa_addr + ALE_OFFSET)
#define CLE_ADDR	(void*)(isa_addr + CLE_OFFSET)


#define init_device() {\
	ctlres = (NCE_OFFSET);\
	writeb(ctlres, CTL_ADDR);\
}

// CHIP ENABLE  
#define smc_enable() {\
	ctlres &= (!NCE_OFFSET);\
	writeb(ctlres, CTL_ADDR);\
}

#define smc_disable() {\
	ctlres |= NCE_OFFSET;\
	writeb(ctlres, CTL_ADDR);\
}

//cmd, addr 
#define smc_write_cmd(x)	writeb(x, CLE_ADDR)
#define smc_write_addr(x)	writeb(x, ALE_ADDR)

//read, write
#define smc_write_data(x)	writeb(x, DATA_ADDR)
#define smc_read_data()		readb(DATA_ADDR)

//cmd read (Data Transfer from Cell to Register)
//忡 ִ 10us  ִµ udelay(10)     Ͱ  ʾƼ 20 ϴ..
#define smc_read_wait() {\
	udelay(20);\
}

//,    ϰ  
#define smc_wait() {\
	udelay(100);\
}


//  ɾ ڵ  
#define CMD_READ_ID			0x90

#define CMD_READ			0x00
#define CMD_READ_SPARE		0x50

#define CMD_BLOCK_ERASE		0x60
#define CMD_BLOCK_ERASE_END	0xD0

#define CMD_READ_STATUS		0x70

#define CMD_PAGE_PROGRAM	0x80
#define CMD_PAGE_PROGRAM_END	0x10

// ȸ ڵ Ｚ
#define	SAMSUNG				0xEC

//   ̵ 
#define TYPE_SAMSUNG_16M		0x73
#define TYPE_SAMSUNG_32M		0x75
#define TYPE_SAMSUNG_64M		0x76
#define TYPE_SAMSUNG_128M		0x79

#define		BAD_BLOCK			0xFFEE
#define		UNUSED_BLOCK		0xFFFF

//  Ҵ Ǿ    
// 0    ǹǷ() 0 ȿ   ȴ
#define		UNASSIGNED_BLOCK	0x00


struct flash_info{
	bool			detect;			//̵ üũ 
	unsigned long	type;

	unsigned short	*pblock;		//  
	unsigned short	*lblock;		//  

	unsigned short	page_size;			//page , (spare   ũ)
	unsigned short	spare_size;			//spare 
	unsigned short	page_per_block;		// page 
	unsigned short	total_pblock;		//  
	unsigned short	total_lblock;		//  

	unsigned short	cylinder;		//ġ Ǹ 
	unsigned char	head;			//Ǹ  
	unsigned char	sector;			//  

	unsigned int	total_sector;	//  ()

	unsigned short	bad_blocks;		//  
};

extern int init_smc(struct flash_info* info);
extern void close_smc(struct flash_info* info);

extern int write_block(struct flash_info *info, ushort lblock_num, uchar* data, ulong size);
extern int read_block(struct flash_info *info, ushort lblock_num, uchar* data, ulong size);

#endif
